.\"	$NetBSD: shmget.2,v 1.21 2008/10/27 15:42:04 erh Exp $
.\"
.\" Copyright (c) 1995 Frank van der Linden
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"      This product includes software developed for the NetBSD Project
.\"      by Frank van der Linden
.\" 4. The name of the author may not be used to endorse or promote products
.\"    derived from this software without specific prior written permission
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd October 27, 2008
.Dt SHMGET 2
.Os
.Sh NAME
.Nm shmget
.Nd get shared memory segment
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In sys/shm.h
.Ft int
.Fn shmget "key_t key" "size_t size" "int shmflg"
.Sh DESCRIPTION
.Fn shmget
returns the shared memory identifier associated with the key
.Fa key .
.Pp
A shared memory segment is created if either
.Fa key
is equal to
.Dv IPC_PRIVATE ,
or
.Fa key
does not have a shared memory segment identifier associated with it, and the
.Dv IPC_CREAT
bit is set in
.Fa shmflg .
If both the
.Dv IPC_CREAT
bit and the
.Dv IPC_EXCL
bit are set in
.Fa shmflg ,
and
.Fa key
has a shared memory segment identifier associated with it already,
the operation will fail.
.Pp
If a new shared memory segment is created, the data structure
associated with it (the
.Va shmid_ds
structure, see
.Xr shmctl 2 )
is initialized as follows:
.Bl -bullet
.It
.Va shm_perm.cuid
and
.Va shm_perm.uid
are set to the effective uid of the calling process.
.It
.Va shm_perm.gid
and
.Va shm_perm.cgid
are set to the effective gid of the calling process.
.It
.Va shm_perm.mode
is set to the lower 9 bits of
.Fa shmflg .
.It
.Va shm_lpid ,
.Va shm_nattch ,
.Va shm_atime ,
and
.Va shm_dtime
are set to 0.
.It
.Va shm_ctime
is set to the current time.
.It
.Va shm_segsz
is set to the value of
.Fa size .
.El
.Sh RETURN VALUES
Upon successful completion a positive shared memory segment identifier
is returned.
Otherwise, \-1 is returned and the global variable
.Va errno
is set to indicate the error.
.Sh ERRORS
.Bl -tag -width Er
.It Bq Er EACCES
A shared memory segment is already associated with
.Fa key
and the caller has no permission to access it.
.It Bq Er EEXIST
Both
.Dv IPC_CREAT
and
.Dv IPC_EXCL
are set in
.Fa shmflg ,
and a shared memory segment is already associated with
.Fa key .
.It Bq Er EINVAL
No shared memory segment is to be created, and a shared memory segment
exists for
.Fa key ,
but the size of the segment associated with it is less
than
.Fa size ,
which is non-zero.
.Pp
A shared memory segment
.Em is
to be created, and
.Fa size
is less than the system imposed minimum, or greater than the system
imposed maximum (refer to the
.Li kern.ipc
values in
.Xr sysctl 7 ) .
.It Bq Er ENOENT
.Dv IPC_CREAT
is not set in
.Fa shmflg
and no shared memory segment associated with
.Fa key
was found.
.It Bq Er ENOMEM
There is not enough memory left to create a shared memory segment of the
requested size.
.It Bq Er ENOSPC
A new shared memory identifier could not be created because the system limit
for the number of shared memory identifiers has been reached.
.El
.Sh SEE ALSO
.Xr ipcrm 1 ,
.Xr ipcs 1 ,
.Xr mmap 2 ,
.Xr shmat 2 ,
.Xr shmctl 2 ,
.Xr ftok 3 ,
.Xr sysctl 7
.Sh STANDARDS
The
.Nm
system call conforms to
.St -xsh5 .
.Sh HISTORY
Shared memory segments appeared in the first release of
.At V .
